routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('admin');
Route::get('/reset-password', function () {
    return View::make('reset-password');
});

Auth::routes();

Route::group(['prefix' => 'admin', 'middleware' => ['auth']],function(){
	Route::get('/dashboard', 'DashboardController@index')->name('dashboard');
	Route::get('users/blocked/{id}', 'UserController@block');
	Route::get('export', 'UserController@export')->name('export');
	Route::resource('users', 'UserController');
	Route::get('workoutPlans/deactivate/{id}', 'WorkoutPlanController@deactivate');
	Route::get('workoutPlans/getSubcategory', 'WorkoutPlanController@getSubcategory')->name('getSubcategory');
	Route::resource('workoutPlans', 'WorkoutPlanController');
	Route::resource('cms', 'CmsPageController');
	Route::get('edit-profile', 'ProfileController@editProfile')->name('edit.profile');
	Route::put('update-profile', 'ProfileController@updateProfile')->name('update.profile');
	Route::get('change-password', 'ProfileController@changePassword')->name('change.password');
	Route::put('update-password', 'ProfileController@updatePassword')->name('update.password');
	Route::resource('subscriptions', 'SubscriptionController');
	Route::resource('forums', 'CommunityBoardController');
	Route::post('forum-comment-delete/{id}', 'CommunityBoardController@deleteComment')->name('delete-comment');
	Route::resource('contactUs', 'InquiryController');
	Route::resource('categories', 'CategoryController');
	Route::resource('subcategories', 'SubcategoryController');
	Route::resource('ageGroups', 'AgeGroupController');
	Route::resource('routines', 'RoutineController');
	Route::resource('reported-forums', 'ReportedForumController');
});

Route::get('cms/{slug}', 'CmsPageController@view_cms');

app/Routine.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Routine extends Model
{
    protected $fillable = [
        'name', 'description', 'image'
    ];
}

app/Http/Controllers/RoutineController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Routine;
use Validator;
use Image;

class RoutineController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $routines = Routine::orderBy('updated_at', 'desc')->get();
        return view('routines.index', compact('routines'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('routines.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $input = $request->input(); 
        $validator =  Validator::make($input,[
            'name' => 'required|string|max:35',
            //'image' => 'required',
            'description' => 'required|max:255',
        ]);

        if ($validator->fails()) {
            return redirect()->back()->withErrors($validator)->withInput();
        }
        
        if ($request->has('image')) {
            $originalImage= $request->file('image');
            $thumbnailImage = Image::make($originalImage);
            $originalPath = public_path().'/categories/';
            $thumbnailImage->save($originalPath.time().$originalImage->getClientOriginalName());

            $input['image'] = time().$originalImage->getClientOriginalName();
        }

        $routine = new Routine();
        $routine->name = $input['name'];
        $routine->image = $input['image'];
        $routine->description = $input['description'];
        $routine->save();

        flash()->success('New Routine added successfully');
        return redirect()->route('routines.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $routine = Routine::findOrFail($id);
        return view('routines.view', compact('routine'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $routine = Routine::findOrFail($id);
        return view('routines.edit', compact('routine'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $input = $request->input();
        $validator =  Validator::make($input,[
            'name' => 'required|string|max:35',
            'description' => 'required|string|max:255',
        ]);

        if ($validator->fails()) {
            return redirect()->back()->withErrors($validator)->withInput();
        }
        
        if ($request->has('image')) {
            $originalImage= $request->file('image');
            $thumbnailImage = Image::make($originalImage);
            $originalPath = public_path().'/categories/';
            $thumbnailImage->save($originalPath.time().$originalImage->getClientOriginalName());

            $input['image'] = time().$originalImage->getClientOriginalName();
        }

        $routine = Routine::findOrFail($id);
        $routine->name = $input['name'];
        if ($request->has('image')) 
            $routine->image = $input['image'];
        $routine->description = $input['description'];
        $routine->save();

        flash()->success("Routine updated successfully.");
        return redirect()->route('routines.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $category = Routine::findOrFail($id);
        if ($category->delete()) {
            $response = array(
                'status' => 'success',
                'message' => 'Routine deleted successfully',
            );
        } else {
            $response = array(
                'status' => 'error',
                'message' => 'Routine can not be deleted.Please try again',
            );
        }
        return json_encode($response);
    }

}

resources/views/routines/create.blade.php
@extends('layouts.web')

@section('top-css')
<style type="text/css">
img{
  max-width:180px;
  max-height:180px;
}
input[type=file]{
    padding:20px;
}
.page-breadcrumb .d-flex {
    justify-content: space-between;
}
</style>
@endsection

@section('content')
<div class="page-wrapper">
    <div class="page-breadcrumb">
        <div class="row">
            <div class="col-12 d-flex no-block align-items-center">
                <h4 class="page-title">Add Routine</h4>
                <a href="{{ route('routines.index') }}" class="btn btn-primary float-right"><i class="fa fa-arrow-left"></i> Back</a>
            </div>
        </div>
    </div>
    <div class="container-fluid">
        <form class="form-horizontal" action="{{ route('routines.store') }}" enctype="multipart/form-data" method="post">
            @csrf
            <div class="card row">
                <div class="col-md-12">
                    <div class="card-body">
                        <h4 class="card-title">Add Routine</h4>
                        <div class="form-group row">
                            <label for="name" class="col-sm-3 text-right control-label col-form-label">Image</label>
                            <div class="col-sm-9">
                                <img id="blah" src="{{ asset('/categories/default.png') }}" alt="Image" />
                                    <br>
                                <input type='file' name="image" value="{{ old('image') }}" onchange="readURL(this);" />
                                <br>
                                <span class="text-danger image_error">
                                    <strong>{{ $errors->has('image')?$errors->first('image'):'' }}</strong>
                                </span>
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="name" class="col-sm-3 text-right control-label col-form-label">Name</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="name" value="{{ old('name') }}" id="name" placeholder="Name">
                                <span class="text-danger image_error">
                                    <strong>{{ $errors->has('name')?$errors->first('name'):'' }}</strong>
                                </span>
                            </div>   
                        </div>
                        <div class="form-group row">
                            <label for="name" class="col-sm-3 text-right control-label col-form-label">Description</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="description" value="{{ old('description') }}" id="description" placeholder="Description">
                                <span class="text-danger image_error">
                                    <strong>{{ $errors->has('description')?$errors->first('description'):'' }}</strong>
                                </span>
                            </div>   
                        </div>
                    </div>
                </div>
                <div class="border-top">
                    <div class="card-body">
                        <button class="btn btn-primary">Submit</button>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
@endsection
@section('footer-script')
<script type="text/javascript">
    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
                $('#blah')
                    .attr('src', e.target.result);
            };

            reader.readAsDataURL(input.files[0]);
        }
    }
    
</script>
@endsection

resources/views/routines/edit.blade.php
@extends('layouts.web')

@section('top-css')
<style type="text/css">
img{
  max-width:180px;
  max-height:180px;
}
input[type=file]{
    padding:20px;
}
</style>
@endsection

@section('content')
<div class="page-wrapper">
    <div class="page-breadcrumb">
        <div class="row">
            <div class="col-12 d-flex no-block align-items-center">
                <h4 class="page-title">Edit Category</h4>
            </div>
        </div>
    </div>
    <div class="container-fluid">
        <form class="form-horizontal" action="{{ route('routines.update' , $routine->id) }}" enctype="multipart/form-data" method="post">
            @csrf
            @method('put')
            <div class="card row">
                <div class="col-md-12">
                    <div class="card-body">
                        <h4 class="card-title">Edit Routine</h4>
                        <div class="form-group row">
                            <label for="image" class="col-sm-3 text-right control-label col-form-label">Image</label>
                            <div class="col-sm-9">
                                @if($routine->image == null)
                                <img id="blah" src="{{ asset('/categories/default.png') }}" alt="Image" />
                                @else
                                <img id="blah" src="{{ asset('/categories/'.$routine->image) }}" alt="Image" />
                                @endif
                                <br>
                                <input type='file' name="image" value="{{ old('image') }}" onchange="readURL(this);" />
                                <br>
                                <span class="text-danger image_error">
                                    <strong>{{ $errors->has('image')?$errors->first('image'):'' }}</strong>
                                </span>
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="name" class="col-sm-3 text-right control-label col-form-label">Name</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="name" id="name" placeholder="Name" value="{{ old('name', $routine->name) }}">
                                <span class="text-danger image_error">
                                    <strong>{{ $errors->has('name')?$errors->first('name'):'' }}</strong>
                                </span>
                            </div>   
                        </div>
                        <div class="form-group row">
                            <label for="name" class="col-sm-3 text-right control-label col-form-label">Description</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="description" id="description" placeholder="description" value="{{ old('description', $routine->description) }}">
                                <span class="text-danger image_error">
                                    <strong>{{ $errors->has('description')?$errors->first('description'):'' }}</strong>
                                </span>
                            </div>   
                        </div>
                    </div>
                </div>
                <div class="border-top">
                    <div class="card-body">
                        <button class="btn btn-primary">Submit</button>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
@endsection

@section('footer-script')
<script type="text/javascript">
    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
                $('#blah')
                    .attr('src', e.target.result);
            };

            reader.readAsDataURL(input.files[0]);
        }
    }
</script>
@endsection

resources/views/routines/index.blade.php
@extends('layouts.web')

@section('content')
<div class="page-wrapper">
    <div class="page-breadcrumb">
        <div class="row">
            <div class="col-12 d-flex no-block align-items-center">
                <h4 class="page-title">Routine Management</h4>
            </div>
        </div>
    </div>
    <div class="container-fluid">
    	@include('flash::message')
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-body">
                        <h5 class="card-title">Routines
	                        <div class="text-right">
	                            <a href="{{ route('routines.create') }}" type="button" class="btn btn-success" >Add</a>
	                        </div>
	                    </h5>
                        <div class="table-responsive">
                            <table id="zero_config" class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th>S.No.</th>
                                        <th>Name</th>
                                        <th>Created At</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                	@foreach($routines as $key => $routine)
                                    <tr>
                                        <td>{{ $key + 1 }}</td>
                                        <td>{{ $routine->name }}</td>
                                        <td>{{ $routine->created_at->format('d M Y') }}</td> 
										<td class="">
											<div class="comment-footer">
	                                            <a href="{{ route('routines.edit', $routine->id) }}" type="button" class="btn btn-cyan btn-sm">Edit</a>
    	                                        <form action="{{ route('routines.destroy', $routine->id) }}" method="POST" onsubmit="deleteRoutine('{{ $routine->id }}', '{{ $routine->name }}', event,this)">
                                                @csrf
                                                    <button class="btn-sm btn-danger" title="">DELETE</button>
                                                </form>
	                                        </div>
										</td>
                                    </tr>
                                    @endforeach
                                </tbody>
                                <tfoot>
                                    <tr>
                                        <th>S.No.</th>
                                        <th>Name</th>
                                        <th>Created At</th>
                                        <th>Action</th>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('footer-script')
<script type="text/javascript">
    $(document).ready( function () {
        $('#zero_config').DataTable({
            "columnDefs": [{ 'orderable': false, 'targets': 3 }],
        });
    });

    function deleteRoutine(id, title, event,form)
    {
        event.preventDefault();
        swal({
            title: "Are you sure?",
            text: "You want to delete "+title+" routine",
            icon: "warning",
            buttons: {
                cancel: true,
                confirm: true,
            },
            closeModal: false,
            closeModal: false,
            closeOnEsc: false,
        })
       .then((willDelete) => {
            if (willDelete) {
                $.ajax({
                url: $(form).attr('action'),
                data: $(form).serialize(),
                type: 'DELETE',
                success: function(data) {
                    data = JSON.parse(data);
                    if(data['status']) {
                        swal({
                            title: data['message'],
                            text: "Press OK to continue",
                            icon: "success",
                            buttons: {
                                cancel: true,
                                confirm: true,
                            },
                            closeOnConfirm: false,
                            closeOnEsc: false,
                        })
                        .then((willDelete) => {
                            if (willDelete) {
                                window.location.reload();
                            }
                            });
                        } else {
                             swal("Error", data['message'], "error");
                        }
                    }
                });
            } else {
                swal("Cancelled", title+" routine will not be deleted.", "error");
            }
        });
    }
</script>
@endsection